// Creates a canvas for back buffering
var getBackCanvas = function(width, height) {
    var backCanvas = document.createElement("canvas");
    backCanvas.width = width;
    backCanvas.height = height;

    return backCanvas;
}

var installRequestFrame = function() {
    // shim layer with setTimeout fallback
    window.requestAnimFrame = (function(){
      return  window.requestAnimationFrame       || 
              window.webkitRequestAnimationFrame || 
              window.mozRequestAnimationFrame    || 
              window.oRequestAnimationFrame      || 
              window.msRequestAnimationFrame     || 
              function( callback ){
                // Not really great. Should rather get the remaining time before
                // setting the new callback
                window.setTimeout(callback, 1000 / 60);
              };
    })();
}


var renderFrame = function(frontCanvas, backCanvas) {
    var frontContext = frontCanvas.getContext("2d");
    var backContext =  backCanvas.getContext("2d");

    var renderInternal = function() {
        backContext.clearRect(0, 0, backCanvas.width, backCanvas.height);
        game.loop(backContext);

        frontContext.clearRect(0, 0, frontCanvas.width, frontCanvas.height);
        frontContext.drawImage(backCanvas, 0, 0);
        requestAnimFrame(renderInternal);
    }
    return renderInternal;
};

installRequestFrame();

var frontCanvas = document.getElementById("surface");
var width = frontCanvas.width;
var height = frontCanvas.height;

renderFrame(frontCanvas, getBackCanvas(width, height))();
